// sbagenceDlg.cpp : implementation file
//
// copyright (c) 2006 Sam C. Lin <lincomatic@hotmail.com> ALL RIGHTS RESERVED
//	Released under the GNU GPL version 2.
//	Use at your own risk.
//
//	" This program is free software; you can redistribute it and/or modify
//	  it under the terms of the GNU General Public License as published by
//	  the Free Software Foundation, version 2.
//	  
//	  This program is distributed in the hope that it will be useful,
//	  but WITHOUT ANY WARRANTY; without even the implied warranty of
//	  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	  GNU General Public License for more details. "
//
//	See the file COPYING for details of this license.
//	


#include "stdafx.h"
#include "sbagence.h"
#include "sbagenceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


  HANDLE g_hDieEvent;


#define MAXLINECNT 500


void PlaySbg(char *fn);
UINT SbaPlayThread (LPVOID lpvoid)
{
  char *fn = (char *)lpvoid;
  PlaySbg(fn);
  return 0;
}

CSbagenceDlg *g_Dlg;
void AddText(char *ss)
{
  char s[256],*p;
  p = s;
  while (*ss) {
    if ((*ss != '\n') && (*ss != '\r')) {
      *p++ = *ss;
    }
    ss++;
  }
  *p = 0;
  
  if (strlen(s)) {
    strcat(s,"\r\n");
    TCHAR t[256];
    MultiByteToWideChar(CP_ACP,0,s,-1,t,256);
    
    COPYDATASTRUCT cpd;
    cpd.dwData = 0;
    cpd.cbData = 256*sizeof(TCHAR);
    cpd.lpData = (void*)t;
    g_Dlg->SendMessage(WM_COPYDATA,
		       (WPARAM)AfxGetApp()->m_pMainWnd->GetSafeHwnd(),
		       (LPARAM)&cpd);
  }
}




/////////////////////////////////////////////////////////////////////////////
// CSbagenceDlg dialog

CSbagenceDlg::CSbagenceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSbagenceDlg::IDD, pParent)
{
  g_Dlg = this;
  g_hDieEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
  m_hPlayThread = INVALID_HANDLE_VALUE;

	//{{AFX_DATA_INIT(CSbagenceDlg)
	m_strEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CSbagenceDlg::~CSbagenceDlg()
{
  CloseHandle(g_hDieEvent);
  SetEvent(g_hDieEvent);
}

void CSbagenceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSbagenceDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strEdit);
	DDV_MaxChars(pDX, m_strEdit, MAXLINECNT);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSbagenceDlg, CDialog)
	//{{AFX_MSG_MAP(CSbagenceDlg)
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBtnExit)
	ON_BN_CLICKED(IDC_BTN_OPEN, OnBtnOpen)
	//}}AFX_MSG_MAP
  ON_WM_COPYDATA()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSbagenceDlg message handlers

BOOL CSbagenceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSbagenceDlg::OnBtnExit() 
{
  PostQuitMessage(0);	
}

#define FDT_OPEN 0
#define FDT_SAVE 1
BOOL FileDialog(OPENFILENAME *ofn,TCHAR *initialdir,DWORD flags,HWND owner,HINSTANCE hinst,TCHAR *filename,int maxlen,TCHAR *title,TCHAR *filter,TCHAR *defext,int dlgtype)
{
  if (!ofn->lStructSize) {
    ofn->lStructSize = sizeof(OPENFILENAME);
#ifndef _WIN32_WCE
    ofn->lpstrCustomFilter = (LPTSTR)NULL;
    ofn->nMaxCustFilter = 0L;
#endif
    ofn->nFilterIndex = 1L;
    //    ofn->nFileOffset = 0;
    //    ofn->nFileExtension = 0;
    //    ofn->lpstrDefExt = NULL;
  }
  
  ofn->hwndOwner = owner;
#ifndef _WIN32_WCE
  ofn->hInstance = hinst;
#endif
  ofn->lpstrFile = filename;
  ofn->nMaxFile = maxlen;
  
  ofn->Flags = flags;
  ofn->lpstrFilter = filter;
  ofn->lpstrInitialDir = initialdir;
  ofn->lpstrFileTitle = NULL;
  ofn->nMaxFileTitle = 0;
  ofn->lpstrTitle = title;
  ofn->lpstrDefExt = defext;
  
  if (dlgtype == FDT_OPEN)
    return GetOpenFileName(ofn);
  else
    return GetSaveFileName(ofn);
}


void CSbagenceDlg::OnBtnOpen() 
{
  if (m_hPlayThread != INVALID_HANDLE_VALUE) {
    SetEvent(g_hDieEvent);
    if (WaitForSingleObject(m_hPlayThread,4000) != WAIT_OBJECT_0) {
		int ii=0;
	}
  }
  ResetEvent(g_hDieEvent);

  OPENFILENAME ofn;
  ZeroMemory(&ofn,sizeof(ofn));
  TCHAR fn[MAX_PATH]=_T("\0");;
  TCHAR initialdir[MAX_PATH] = _T(".");
  if (FileDialog(&ofn,initialdir,
		 OFN_FILEMUSTEXIST|OFN_NODEREFERENCELINKS,
		 m_hWnd,AfxGetInstanceHandle(),fn,MAX_PATH,
		 _T("Open SBG File"),_T("SBG Files (*.sbg)\0*.sbg\0"),_T("sbg"),FDT_OPEN)
      && *fn) {
    m_iLineCnt = 0;
        m_strEdit = fn;
        m_strEdit += "\r\n";
        UpdateData(FALSE);
    WideCharToMultiByte(CP_ACP,0,fn,lstrlen(fn)+1,mfn,MAX_PATH,NULL,NULL);
    CWinThread *wt = AfxBeginThread((AFX_THREADPROC)SbaPlayThread,(LPVOID)mfn,THREAD_PRIORITY_NORMAL);
    if (wt) {
      m_hPlayThread = wt->m_hThread;
    }
  }
}
LRESULT CSbagenceDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
  m_iLineCnt++;
  PTCHAR t = (PTCHAR) (pCopyDataStruct->lpData);
  if (m_iLineCnt == MAXLINECNT) {
    m_iLineCnt = 1;
    m_strEdit = t;
  }
  else {
    m_strEdit += t;
  }
  UpdateData(FALSE);
  GetDlgItem(IDC_EDIT1)->PostMessage(EM_LINESCROLL,0,m_iLineCnt*2);
  return 0;
}
